#include "opentyr.h"
#include "tyrian2.h"

#include "animlib.h"
#include "backgrnd.h"
#include "destruct.h"
#include "episodes.h"
#include "error.h"
#include "fonthand.h"
#include "helptext.h"
#include "joystick.h"
#include "keyboard.h"
#include "loudness.h"
#include "lvllib.h"
#include "lvlmast.h"
#include "mainint.h"
#include "network.h"
#include "newshape.h"
#include "nortsong.h"
#include "pallib.h"
#include "params.h"
#include "pcxload.h"
#include "pcxmast.h"
#include "picload.h"
#include "setup.h"
#include "sndmast.h"
#include "starfade.h"
#include "varz.h"
#include "vga256d.h"
#include "cheat.h"

#include "config.h" // For fullscreen stuff

//#include <oslib/oslib.h>
//#include <pspkernel.h>

#include "SDL.h"
#include "SDL_image.h"

int psp_osk_active = 0;
int psp_osk_caps = 0;

unsigned int __attribute__((aligned(16))) list[262144];

extern char curchar;

char osk_keys_upper[] = "1234567890QWERTYUIOPASDFGHJKL:ZXCVBNM,.? ;-\n";
char osk_keys_lower[] = "1234567890qwertyuiopasdfghjkl:zxcvbnm,.? ;-\n";

int osk_key_x_u[] = {
	334,345,359,375,390,406,420,435,450,465,
	335,352,369,383,398,412,427,440,452,466,
	338,354,368,384,398,410,425,440,454,465,
	338,352,368,382,398,412,429,443,452,463,
	390,418,428,
	400
};

int osk_key_x_l[] = {
	334,345,359,375,390,406,420,435,450,465,
	336,353,369,383,396,410,425,436,448,463,
	342,356,370,382,398,412,428,442,452,462,
	340,354,370,384,398,412,426,440,450,460,
	390,418,428,
	400
};

int osk_key_y[] = {
	80,80,80,80,80,80,80,80,80,80,
	112,112,112,112,112,112,112,112,112,112,
	144,144,144,144,144,144,144,144,144,144,
	176,176,176,176,176,176,176,176,176,176,
	208,208,208,
	242
};

int osk_pos = 0;

void clearKeys(Uint8 *keysactive) {
	int i;
	for (i=8; i<320; i++)
		keysactive[i]=0;
}

void clearScreen(long color) {
        memset(pixels,0x00000000,sizeof(pixels));
	int i=fullscreen_set;
	fullscreen_set=1;
	guBlit();
	guBlit();
	fullscreen_set=i;
}

void guStart() {
        sceGuStart(GU_DIRECT,list);
}

void guInit(void) {
        sceGuInit();
        guStart();
        sceGuDrawBuffer(GU_PSM_5551,(void*)0,512);
        sceGuDispBuffer(480,272,(void*)0x88000,512);
        sceGuDepthBuffer((void*)0x110000,512);
        sceGuOffset(2048 - (480/2),2048 - (272/2));
        sceGuViewport(2048,2048,480,272);
        sceGuDepthRange(0xc350,0x2710);
        sceGuScissor(0,0,480,272);
        sceGuEnable(GU_SCISSOR_TEST);
        //sceGuFrontFace(GU_CW);
        sceGuEnable(GU_TEXTURE_2D);
        sceGuClear(GU_COLOR_BUFFER_BIT|GU_DEPTH_BUFFER_BIT);
        sceGuTexFunc(GU_TFX_REPLACE,GU_TCC_RGB);
        sceGuTexFilter(GU_LINEAR,GU_LINEAR);
        sceGuTexMode(GU_PSM_5551,0,0,0);
        sceGuTexScale(1,1);
        sceGuTexOffset(0.0f,0.0f);
        sceGuAmbientColor(0x000000);
        sceGuFinish();
        sceGuSync(0,0);

        sceDisplayWaitVblankStart();
        sceGuDisplay(1);
}

int j;
float ratio=480.0/320.0;

int frame=0;

void guBlit () {
        //sceKernelDcacheWritebackAll();
        guStart();

        sceGuTexImage(0,512,512,512,pixels);
        //sceGuTexFlush();
        for (j = 0; (j+SLICE_SIZE) <= 320; j = j+SLICE_SIZE) {
                vertices = (struct Vertex*)sceGuGetMemory(2 * sizeof(struct Vertex));
				if (psp_osk_active)
				{
                        vertices[0].x = j+0; vertices[0].y = 36; vertices[0].z = 0;
                        vertices[1].x = (j+SLICE_SIZE)+0; vertices[1].y = 236; vertices[1].z = 0;
				} else if (fullscreen_set==1) {
                        vertices[0].x = j*ratio; vertices[0].y = 0; vertices[0].z = 0;
                        vertices[1].x = (j+SLICE_SIZE)*ratio; vertices[1].y = 272; vertices[1].z = 0;
                } else {
                        vertices[0].x = j+80; vertices[0].y = 36; vertices[0].z = 0;
                        vertices[1].x = (j+SLICE_SIZE)+80; vertices[1].y = 236; vertices[1].z = 0;
                }
                vertices[0].u = j; vertices[0].v = 1;
                vertices[1].u = j+SLICE_SIZE; vertices[1].v = 200;

                sceGuDrawArray(GU_SPRITES,GU_TEXTURE_16BIT|GU_COLOR_5551|GU_VERTEX_16BIT|GU_TRANSFORM_2D,2,0,vertices);
				
        }
		
		if (psp_osk_active)
		{
			int cursor_x;
		
			if(psp_osk_caps==1)
			{
				sceGuTexImage(0,256,256,256,osk_upixels);
				cursor_x=osk_key_x_u[osk_pos];
			}
			else
			{
				sceGuTexImage(0,256,256,256,osk_lpixels);
				cursor_x=osk_key_x_l[osk_pos];
			}
				
            vertices = (struct Vertex*)sceGuGetMemory(2 * sizeof(struct Vertex));
			vertices[0].x = 321; vertices[0].y=8; vertices[0].z = 0;
			vertices[1].x = 480; vertices[1].y=264; vertices[0].z=0;
			vertices[0].u = 0; vertices[0].v = 0;
            vertices[1].u = 160; vertices[1].v = 256;
			sceGuDrawArray(GU_SPRITES,GU_TEXTURE_16BIT|GU_COLOR_5551|GU_VERTEX_16BIT|GU_TRANSFORM_2D,2,0,vertices);
			
			sceGuTexImage(0,16,16,16,osk_cpixels);
            vertices = (struct Vertex*)sceGuGetMemory(2 * sizeof(struct Vertex));
			vertices[0].x = cursor_x-8; vertices[0].y=osk_key_y[osk_pos]; vertices[0].z = 0;
			vertices[1].x = cursor_x+8; vertices[1].y=osk_key_y[osk_pos]+8; vertices[0].z=0;
			vertices[0].u = 0; vertices[0].v = 0;
            vertices[1].u = 16; vertices[1].v = 8;
			sceGuDrawArray(GU_SPRITES,GU_TEXTURE_16BIT|GU_COLOR_5551|GU_VERTEX_16BIT|GU_TRANSFORM_2D,2,0,vertices);
		}

        sceGuFinish();
        sceGuSync(0,0);
        //sceDisplayWaitVblankStart();
        sceGuSwapBuffers();
}

void copyOSKu(SDL_Surface *s) {
		int x,y;
		int i=0;
		Uint8 index;
        SDL_Color color;
		for(x=0; x <256; x++)
		{
			for(y=0; y<256; y++)
			{
				index= *(Uint8 *) (&s->pixels[i]);
                color= (s->format->palette->colors[index]);
                osk_upixels[i]=RGB2(color.r,color.g,color.b);
				i++;
			}
		}
}

void copyOSKl(SDL_Surface *s) {
		int x,y;
		int i=0;
		Uint8 index;
        SDL_Color color;
		for(x=0; x <256; x++)
		{
			for(y=0; y<256; y++)
			{
				index= *(Uint8 *) (&s->pixels[i]);
                color= (s->format->palette->colors[index]);
                osk_lpixels[i]=RGB2(color.r,color.g,color.b);
				i++;
			}
		}
}


void copyOSKcursor(SDL_Surface *s) {
		int x,y;
		int i=0;
		Uint8 index;
        SDL_Color color;
		for(x=0; x <16; x++)
		{
			for(y=0; y<8; y++)
			{
				index= *(Uint8 *) (&s->pixels[i]);
				color= (s->format->palette->colors[index]);
				osk_cpixels[i]=RGB2(color.r,color.g,color.b);
				i++;
			}
		}
}


void copyScreen(SDL_Surface *s) {
        int i,j;
        int x=0;
        int y=0;
        Uint8 index;
        SDL_Color color;
	frame++;
        for (i=0; i<200; i++) {
                for (j=0; j<263+(frame%2)*57; j++) {
                        index= *(Uint8 *) (&s->pixels[j+y]);
                        color= (s->format->palette->colors[index]);
					    pixels[x+j]=RGB2(color.r,color.g,color.b);
                }
                x+=512;
                y+=320;
        }
}

void copyScreen8(SDL_Surface *s) {
        int x=0;
        int y=0;
		int i=0;
        Uint8 index;
//        SDL_Color color;
		
		for(x=0; x <512; x++)
		{
			for(y=0; y<512; y++)
			{
				if(x>=320 || y>=200)
				{
					pixels8[i]=0;
				}
				else
				{
					index= *(Uint8 *) (&s->pixels[x+(y*320)]);
					pixels8[i]=index;
				}
				i++;
			}
		}
}

void psp_init() {
	SDL_Surface *osk_bg;
	SDL_Surface *osk_bg2;
	SDL_Surface *osk_cursor;

//    pspDebugScreenSetBackColor(0x00000000);
//    pspDebugScreenClear();
//    sceKernelDelayThread(500000);
//    pspDebugScreenPrintf("\n");
//	pspDebugScreenPrintf("Loading uppercase OSK.");
	if(osk_bg = IMG_Load("psp/osk_upper.png"))
	{
		copyOSKu(osk_bg);
	}
	else
		JE_tyrianHalt(-5);
	
//	pspDebugScreenPrintf("Loading lowercase OSK.");
	if(osk_bg2 = IMG_Load("psp/osk_lower.png"))
	{
		copyOSKl(osk_bg2);
	}
	else
		JE_tyrianHalt(-5);
		
//	pspDebugScreenPrintf("Loading OSK cursor.");
	if(osk_cursor = IMG_Load("psp/cursor.png"))
	{
		copyOSKcursor(osk_cursor);
	}
	else
		JE_tyrianHalt(-5);	
}

#if 0
void pspFlip(SDL_Surface *s) {
{
	copyScreen8(s);
	guBlit8();
}

#else
void pspFlip(SDL_Surface *s) {

	copyScreen(s);
       	guBlit();
}
#endif

void osk_pos_down()
{
	if(osk_pos==43)
	{
		osk_pos=0;
	}
	else if(osk_pos>=40)
	{
		osk_pos=43;
	}
	else if(osk_pos>=30)
	{
		osk_pos=40;
	}
	else
		osk_pos+=10;
		
}

void osk_pos_up()
{
	if(osk_pos<10)
	{
		osk_pos=43;
	}
	else if (osk_pos==43)
	{
		osk_pos=40;
	}
	else
		osk_pos-=10;
}

char osk_get_curchar()
{
	if(psp_osk_caps)
		return osk_keys_upper[osk_pos];
	else
		return osk_keys_lower[osk_pos];
}

void osk_shift()
{
	psp_osk_caps = !psp_osk_caps;
}

void pspJoystick(Sint16 * joyX, Sint16 * joyY) {
	static int osk_poll_wait=0;
	*joyY=0;
    *joyX=0;
    sceCtrlPeekBufferPositive(&cpad,1);
	if(psp_osk_active)
	{
		if(osk_poll_wait==0)
		{
			if (cpad.Buttons & PSP_CTRL_LEFT ||  cpad.Lx <= 0x30)
			{
					osk_pos--;
					osk_poll_wait=3;
					JE_playSampleNum(CURSOR_MOVE);
			}
			if (cpad.Buttons & PSP_CTRL_RIGHT ||  cpad.Lx >= 0xD0)
			{
					osk_pos++;
					osk_poll_wait=3;
					JE_playSampleNum(CURSOR_MOVE);
			}
			if (cpad.Buttons & PSP_CTRL_UP ||  cpad.Lx <= 0x30)
			{
					osk_pos_up();
					osk_poll_wait=3;
					JE_playSampleNum(CURSOR_MOVE);
			}
			if (cpad.Buttons & PSP_CTRL_DOWN ||  cpad.Lx >= 0xD0)
			{
					osk_pos_down();
					osk_poll_wait=3;
					JE_playSampleNum(CURSOR_MOVE);
			}
					
			if(osk_pos>43)
				osk_pos=0;
			if(osk_pos<0)
				osk_pos=43;
		}
		else
		{
			osk_poll_wait--;
		}
	}
	else
	{
        if (cpad.Buttons & PSP_CTRL_UP ||  cpad.Ly <= 0x30)
                *joyY = -3000;
        if (cpad.Buttons & PSP_CTRL_DOWN ||  cpad.Ly >= 0xD0)
                *joyY = 3000;
        if (cpad.Buttons & PSP_CTRL_LEFT ||  cpad.Lx <= 0x30)
                *joyX = -3000;
        if (cpad.Buttons & PSP_CTRL_RIGHT ||  cpad.Lx >= 0xD0)
                *joyX = 3000;
	}
}

void pspPlayEndingAnim(int speed)
{
	int i;
	char frame_filename[30];
	
	setjasondelay(speed);
	
	for(i=1;i<=111;i++)
	{
		sprintf(frame_filename,"ending/end%03d.pcx",i);

		JE_loadPCX(frame_filename,1);
		SDL_SetColors(display_surface, colors, 0, 256);
		pspFlip(VGAScreen);
	}
}

void getOSK()
{
	guBlit();
//	pspDebugScreenClear();
	clearScreen(0x11111111);
	psp_osk_active= 1;
//	JE_playSampleNum(ESC);
	clearScreen(0x11111111);
	guBlit();
}

void closeOSK()
{
	guBlit();
//	pspDebugScreenClear();
	clearScreen(0x11111111);
	psp_osk_active=0;
//	JE_playSampleNum(ESC);
	clearScreen(0x11111111);
	guBlit();
}

#if 0
void getOSK() {
                JE_playSampleNum(CLICK);
                SceCtrlData cpad;
		pspDebugScreenInit();
                pspDebugScreenSetBackColor(0x00000000);
                pspDebugScreenClear();
                sceKernelDelayThread(500000);
                pspDebugScreenSetBackColor(0x00551111);
                pspDebugScreenPrintf("\n\n\t\t\t\t\tONSCREEN KEYBOARD\n\n\n\t\tUSE UP & DOWN ARROWS TO CHANGE THE LETTER,\n\n\t\t\t THEN HIT RIGHT TRIGGER\n\n\n");
                pspDebugScreenSetBackColor(0x00330000);
		pspDebugScreenPrintf("\n\n\n\n\n");
                sceCtrlPeekBufferPositive(&cpad,1);
                while (!(cpad.Buttons & PSP_CTRL_RTRIGGER)) {
                        pspDebugScreenSetXY(0,13);
                        pspDebugScreenPrintf("==> %c", curchar);
			sceGuSwapBuffers();
		
                        if (cpad.Buttons & PSP_CTRL_UP||  cpad.Ly <= 0x30) {
                                curchar++;
                                JE_playSampleNum(CURSOR_MOVE);
                                sceKernelDelayThread(130000);
                        }
                        if (cpad.Buttons & PSP_CTRL_DOWN || cpad.Ly >= 0xD0) {
                                curchar--;
                                JE_playSampleNum(CURSOR_MOVE);
                                sceKernelDelayThread(130000);
                        }
                sceCtrlPeekBufferPositive(&cpad,1);

                }
                JE_playSampleNum(SELECT);
		guInit();
		clearScreen(0x00000000);
                sceKernelDelayThread(90000);
}
#endif

int psp_modes_menu( void )
{
	int sel = 0;
	int maxSel = SA+1;
	bool quit = false, fade_in = true;

	JE_fadeBlack(10);
	JE_loadPic(2, false); /* 2, 5, or 13? */

	JE_outTextAdjust(JE_fontCenter("Special Modes", FONT_SHAPES), 5, "Special Modes", 15, -3, FONT_SHAPES, false);

	memcpy(VGAScreen2->pixels, VGAScreen->pixels, VGAScreen2->pitch * VGAScreen2->h);

	JE_showVGA();

	do
	{
		memcpy(VGAScreen->pixels, VGAScreen2->pixels, VGAScreen->pitch * VGAScreen->h);
		for ( int i = 0; i <= maxSel; i++)
		{
			const char *text = specialName[i];
			JE_outTextAdjust(JE_fontCenter(text, SMALL_FONT_SHAPES),(i * 16 + 32), text, 15, (i != sel ? -4 : -2), SMALL_FONT_SHAPES, true);
		}

		JE_showVGA();

		if (fade_in)
		{
			fade_in = false;
			JE_fadeColor(20);
			wait_noinput(true, false, false);
		}

		tempW = 0;
		JE_textMenuWait(&tempW, false);

		if (newkey) {
			switch (lastkey_sym)
			{
				case SDLK_UP:
					sel--;
					if (sel < 0)
					{
						sel = maxSel;
					}
					JE_playSampleNum(CURSOR_MOVE);
					break;
				case SDLK_DOWN:
					sel++;
					if (sel > maxSel)
					{
						sel = 0;
					}
					JE_playSampleNum(CURSOR_MOVE);
					break;
				case SDLK_RETURN:
					JE_playSampleNum(SELECT);
					return (sel);
					break;
				case SDLK_ESCAPE:
					quit = true;
					JE_playSampleNum(ESC);
					return (-1);
				default:
					break;
			}
		}
	} while (!quit);
	return (-1);
}

int psp_cheat_menu()
{
	int sel = 0;
	int maxSel = 8;
	bool quit = false, fade_in = true;

//	JE_fadeBlack(10);
//    JE_loadPic(2, false); /* 2, 5, or 13? */
//	JE_loadPCX("ending/end001.pcx",1);

	JE_fadeBlack(10);
	JE_loadPic(1, false);
	JE_clr256();

	JE_outTextAdjust(JE_fontCenter("Keyboard", FONT_SHAPES), 5, "Keyboard", 15, -3, FONT_SHAPES, false);

	memcpy(VGAScreen2->pixels, VGAScreen->pixels, VGAScreen2->pitch * VGAScreen2->h);

	JE_showVGA();

	do
	{
		memcpy(VGAScreen->pixels, VGAScreen2->pixels, VGAScreen->pitch * VGAScreen->h);
		for ( int i = 0; i <= maxSel; i++)
		{
			const char *text = cheat_options[i];
			JE_outTextAdjust(JE_fontCenter(text, SMALL_FONT_SHAPES),(i * 32 + 40), text, 15, (i != sel ? -4 : -2), SMALL_FONT_SHAPES, true);
		}

		JE_showVGA();

		if (fade_in)
		{
			fade_in = false;
			JE_fadeColor(20);
			wait_noinput(true, false, false);
		}

		tempW = 0;
		JE_textMenuWait(&tempW, false);

		if (newkey) {
			switch (lastkey_sym)
			{
				case SDLK_UP:
					sel--;
					if (sel < 0)
					{
						sel = maxSel;
					}
					JE_playSampleNum(CURSOR_MOVE);
					break;
				case SDLK_DOWN:
					sel++;
					if (sel > maxSel)
					{
						sel = 0;
					}
					JE_playSampleNum(CURSOR_MOVE);
					break;
				case SDLK_RETURN:
					JE_playSampleNum(SELECT);
					return (sel);
					break;
				case SDLK_ESCAPE:
					quit = true;
					JE_playSampleNum(ESC);
					return (-1);
				default:
					break;
			}
		}
	} while (!quit);
	clearScreen(0x00000000);
    guInit();
	return (-1);
}