#include <pspdebug.h>
#include <pspctrl.h>
#include <pspdisplay.h>
#include <psppower.h>
#include <pspgu.h>
#include "SDL.h"

#ifndef PSP_H
#define PSP_H
SceCtrlData cpad;

extern int psp_osk_active;

extern char osk_keys_upper[];
extern char osk_keys_lower[];
extern int osk_pos;

//#define printf pspDebugScreenPrintf 

#define SLICE_SIZE 64 // change this to experiment with different page-cache sizes
#define RGB2(r,g,b) (short)((((b>>3) & 0x1F)<<10)|(((g>>3) & 0x1F)<<5)|(((r>>3) & 0x1F)<<0)|0x8000)
#define ARGB2(r,g,b) ((b<<16)|(g<<8)|r)
#define pg_vramtop ((char *)0x04000000)
Uint8 pixels8[512*512]; 

unsigned short __attribute__((aligned(16))) pixels[512*272];
unsigned short __attribute__((aligned(16))) osk_upixels[256*256];
unsigned short __attribute__((aligned(16))) osk_lpixels[256*256];
unsigned short __attribute__((aligned(16))) osk_cpixels[16*16];

struct Vertex
{
        unsigned short u, v;
        unsigned short color;
        short x, y, z;
};


struct Vertex* vertices;

void psp_init();
void clearScreen(long color);
void guStart();
void guInit(void);
void guBlit ();
void copyScreen(SDL_Surface *s);
void pspFlip(SDL_Surface *s);
void pspJoystick(Sint16 * joyX, Sint16 * joyY);
void getOSK();
void closeOSK();
void osk_shift();
void clearKeys(Uint8 *keysactive);
char osk_get_curchar();
void psp_screenshot();
#endif